﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamComboEditorTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        #region Properties

        public ObservableCollection<Item> ActiveItems
        {
            get;
            set;
        }

        private Item _selectedItem;

        public Item SelectedItem
        {
            get
            {
                return _selectedItem;
            }
            set
            {
                if ( _selectedItem != value )
                {
                    _selectedItem = value;
                    OnPropertyChanged("SelectedItem");
                }
            }
        }

        #endregion Properties

        #region INotifyPropertyChanged Implementation

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if ( PropertyChanged != null )
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        protected void SetProperty<T>(ref T field, T value, string propertyName)
        {
            field = value;
            if ( PropertyChanged != null )
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion INotifyPropertyChanged Implementation

        public MainWindow()
        {
            InitializeComponent();

            ActiveItems = new ObservableCollection<Item>();
            ActiveItems.Add(new Item
            {
                DisplayName = "a"
            });
            ActiveItems.Add(new Item
            {
                DisplayName = "ab"
            });
            ActiveItems.Add(new Item
            {
                DisplayName = "abc"
            });
            ActiveItems.Add(new Item
            {
                DisplayName = "xyz"
            });
            ActiveItems.Add(new Item
            {
                DisplayName = "x"
            });

            this.DataContext = this;
        }
    }

    public class Item
    {
        public string DisplayName
        {
            get;
            set;
        }
    }
}